mod Ex02a

incl Mtex

loc rem 
  2. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE

rem 
  VASE MENO: ?
  VERZIA CL: 5.81.16
  DATUM: utorok 21.2.2006
  ******************************************************************************
  MAIL: komara@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0506ls/
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane rekurzii s mierou 
  a definiciam predikatov. 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  ex02*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Fibonacci sequence.  \end 

fun Fib 'Tex_f1_n_fib'
  Fib(n) = Foo

rem 
  \para \bf  Integer division.  \end Specification: 
  \eq* 
    y != 0 -> \e r(x = x/y*y+r & r < y)
  \end
  \para Find a course of values recursive definition of the integer division 
  function. 

fun/2 Div 'Tex_f2_n_div'
  Div(x,y) = Foo

rem 
  \para \bf  Remainder.  \end Specification: 
  \eq* 
    y != 0 -> \e q(x = q*y+x mod y & x mod y < y)
  \end
  \para Find a course of values recursive definition of the remainder function. 

fun/2 Mod 'Tex_f2_n_mod'
  Mod(x,y) = Foo

rem 
  \para \bf  Subsection. Course of Values Recursion with Substitution in 
  Parameters.  \end 

rem 
  \para \bf  Divisibility predicate.  \end 

pred/2 Divides 'Tex_p2_n_divides'
  Divides(x,y) <-> \e z y = x*z

rem 
  \para \bf  Greatest common divisor (Euclid's Algorithm).  \end Specification: 
  \eq* 
    x != 0 \/ y != 0 -> 
    Divides(Texm_f2_n_gcd(x,y),x) & Divides(Texm_f2_n_gcd(x,y),y)
  \end
  \eq* 
    (x != 0 \/ y != 0) & Divides(z,x) & Divides(z,y) -> z <= Texm_f2_n_gcd(x,y)
  \end
  \para Find a course of values recursive definition of the greatest common 
  divisor function based on the property 
  \eq* 
    y != 0 & Divides(z,y) -> Divides(z,x) <-> Divides(z,x mod y)
  \end

fun/2 Gcd1 'Tex_f2_n_gcd'
  Gcd1(x,y) = Foo

rem 
  \para \bf  Subsection. Course of Values Recursion with Measure.  \end 

rem 
  \para \bf  Greatest common divisor.  \end Specification: 
  \eq* 
    x != 0 & y != 0 -> 
    Divides(Texm_f2_n_gcd(x,y),x) & Divides(Texm_f2_n_gcd(x,y),y)
  \end
  \eq* 
    x != 0 & y != 0 & Divides(z,x) & Divides(z,y) -> z <= Texm_f2_n_gcd(x,y)
  \end
  \para Find a course of values recursive definition of the greatest common 
  divisor function based on the property 
  \eq* 
    x < y & Divides(z,x) -> Divides(z,y) <-> Divides(z,y-x)
  \end

fun/2 Gcd2 'Tex_f2_n_gcd'
  Gcd2(x,y) = Foo

