mod Ex02b

incl Mtex

loc rem 
  2. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE

rem 
  VASE MENO: ?
  VERZIA CL: 5.81.16
  DATUM: utorok 21.2.2006
  ******************************************************************************
  MAIL: komara@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0506ls/
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane rekurzii s mierou 
  a definiciam predikatov. 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  ex02*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Part. Explicit definitions of predicates.  \end 

rem 
  \para \bf  [CL] Bounded formulas.  \end Examples: 
  \items 
   \item \para atomic formulas: \ft x = y \end, \ft R(x) \end, 
   \item \para propositional connectives: \ft \t \end, \ft \f \end, \ft ~R \end, 
         \ft R & Q \end, \ft R \/ Q \end, \ft R -> Q \end, and \ft R <-> Q \end, 
   \item \para bounded quantifiers: \ft \eb y y <= x: R \end, 
         \ft \eb y y < x: R \end, \ft \ab y y <= x: R \end, and 
         \ft \ab y y < x: R \end. 
  \end

rem 
  \para \bf  [CL] Explicit definitions of predicates with bounded formulas. 
   \end \header* pred/2 Q  \end Examples: 
  \def 
    pred R 
    R(x) <-> \eb y y <= x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> \eb y y < x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> 
      \ab y y <= x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> 
      \ab y y < x: Q(x,y)
  \end

rem 
  \para \bf  \ft Tex0m_sigma0 \end-predicates.  \end 
  \ft Tex0m_sigma0 \end-predicates are defined by bounded formulas in the 
  language of first-order arithmetic (decimal constants, addition, 
  multiplication, comparision predicates). 

rem 
  \para \bf  Square.  \end Show that the predicate 
  \eq* 
    Square(x) <-> \e y x = Sq(y)
  \end
  \para is a \ft Tex0m_sigma0 \end-predicate. 

pred Square 
  Square(x) <-> Poo

rem 
  \para \bf  Sum of two squares.  \end Find a \ft Tex0m_sigma0 \end-definition 
  of the predicate \ft Sum_of_two_squares(x) \end which holds if \ft x \end is 
  the sum of two squares. 

pred Sum_of_two_squares 
  Sum_of_two_squares(x) <-> Poo

rem 
  \para \bf  Divisibility.  \end Find a \ft Tex0m_sigma0 \end-definition of the 
  divisibility predicate. 

pred/2 Divides 'Tex_p2_n_divides'
  Divides(x,y) <-> Poo

rem 
  \para \bf  Primes.  \end Show that the predicate \ft Prime(x) \end holding of 
  prime numbers is a \ft Tex0m_sigma0 \end-predicate. 

pred Prime 
  Prime(x) <-> Poo

rem 
  \para \bf  Powers of two.  \end Show that the predicate 
  \eq* 
    Pow2(x) <-> \e n x = Texm_f2_n_exp(2,n)
  \end
  \para is a \ft Tex0m_sigma0 \end-predicate. 

pred Pow2 
  Pow2(x) <-> Poo

rem 
  \para \bf  Powers of four.  \end Show that the predicate 
  \eq* 
    Pow4(x) <-> \e n x = Texm_f2_n_exp(4,n)
  \end
  \para is a \ft Tex0m_sigma0 \end-predicate. 

pred Pow4 
  Pow4(x) <-> Poo

rem 
  \para \bf  Powers of a prime.  \end \header* pred/2 Powprime  \end Show that 
  the predicate 
  \eq* 
    Powprime(x,p) <-> Prime(p) & \e n x = Texm_f2_n_exp(p,n)
  \end
  \para is a \ft Tex0m_sigma0 \end-predicate. 

pred/2 Powprime 
  Powprime(x,p) <-> Poo

rem 
  \para \bf  Powers of primes.  \end Show that the predicate 
  \eq* 
    Powprime(x) <-> \e p(Prime(p) & \e n x = Texm_f2_n_exp(p,n))
  \end
  \para is a \ft Tex0m_sigma0 \end-predicate. 

pred Powprimes 
  Powprimes(x) <-> Poo

rem 
  \para \bf  Part. Recursive definitions of predicates.  \end 

rem 
  \para \bf  Exercise.  \end Find a primitive recursive definition of the 
  predicate 
  \eq* 
    Even(x) <-> \e y x = 2*y
  \end

pred Even 
  Even(x) <-> Poo

rem 
  \para \bf  Exercise.  \end Find a course of values recursive definition of the 
  predicate 
  \eq* 
    Odd(x) <-> \e y x = 2*y+1
  \end
  \para which is based on the property 
  \eq* 
    Odd(x) <-> x = 1 \/ \e y(x = y+2 & Odd(y))
  \end

pred Odd 
  Odd(x) <-> Poo

