mod Ex02c

incl Mtex

loc rem 
  2. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE

rem 
  VASE MENO: ?
  VERZIA CL: 5.81.16
  DATUM: utorok 21.2.2006
  ******************************************************************************
  MAIL: komara@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0506ls/
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane rekurzii s mierou 
  a definiciam predikatov. 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  ex02*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Integer Square Root (case study).  \end Specification: 
  \eq* 
    Sq Texm_f1_n_sqrt(x) <= x & x < Sq(Texm_f1_n_sqrt(x)+1)
  \end

rem 
  \para \bf  [CL] Remark.  \end Note that the square function 
  \def 
    fun Sq 'Tex_f1_n_sq'
    Sq(x) = x*x
  \end
  \para is defined in the included module \it  Standard  \end. 

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Primitive Recursion.  \end 

rem 
  \para \bf  Square root function.  \end 

fun Sqrt1 'Tex_f1_n_sqrt'
  Sqrt1(x) = Foo

rem 
  \para \bf  Square root with assignments.  \end 

fun Sqrt2 'Tex_f1_n_sqrt'
  Sqrt2(x) = Foo

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Subsection. Course of Values Recursion with Measure.  \end 

rem 
  \para \bf  Bottom up program for the square root function I.  \end 

fun/2 F3 'Tex_f2_f'
  F3(x,r) = Foo

rem 
  \para Invariant 
  \eq* 
    Sq(r) <= x -> Sq F3(x,r) <= x & x < Sq(F3(x,r)+1)
  \end

fun Sqrt3 'Tex_f1_n_sqrt'
  Sqrt3(x) = Foo

rem 
  \para \bf  Bottom up program for the square root function II.  \end 

fun/3 F4 'Tex_f3_f'
  F4(x,r,s) = Foo

rem 
  \para Invariant 
  \eq* 
    Sq(r) <= x -> Sq F4(x,r,Sq(r)) <= x & x < Sq(F4(x,r,Sq(r))+1)
  \end

fun Sqrt4 'Tex_f1_n_sqrt'
  Sqrt4(x) = Foo

rem 
  \para \bf  Section. Recursion on Notation.  \end 

rem 
  \para \bf  Subsection. \ft p \end-ary arithmetic.  \end 

rem 
  \para \bf  A fast program for the square root function.  \end 

fun Sgn 'Tex_f1_n_sgn'
  Sgn(0) = 0
  Sgn(x) = 1 <- x != 0

fun Sqrt5 'Tex_f1_n_sqrt'
  Sqrt5(x) = Foo <- x = 4*y+z & 0 <= z & z <= 3

